------------------------------------------------------------------------------------------
-- Main file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Import librarys --
------------------------------------------------------------------------------------------
import "Homeopatix.AltHolic.Librarys";
------------------------------------------------------------------------------------------
-- Load the datas --
------------------------------------------------------------------------------------------
CreateLocalizationInfo();
------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
CreateMainWindow(400, 300);


settings["sessionCash"]["cashSession"] = 0;
settings["sessionCash"]["cashSpent"] = 0;

settings["isWindowVisible"]["isWindowVisible"] = true;
settings["isShowBagVisible"]["isShowBagVisible"] = false;
settings["isOptionsWindowVisible"]["isOptionsWindowVisible"] = false;
settings["isShowVaultVisible"]["isShowVaultVisible"] = false;
settings["isShowSharedStorageVisible"]["isShowSharedStorageVisible"] = false;
settings["isShowEquipmentVisible"]["isShowEquipmentVisible"] = false;
settings["isShowWalletVisible"]["isShowWalletVisible"] = false;
settings["nameAccount"]["account1"]["isVisible"] = false;
settings["isLvlEquipWindowVisible"]["isLvlEquipWindowVisible"] = false;
------------------------------------------------------------------------------------------
-- Closing window handler
------------------------------------------------------------------------------------------
UpdateMainWindow();
ClosingTheWindow();
------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
local iconSize = 32;

MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, iconSize, iconSize, AltHolicWindow:SetVisible(false));
MainTinyIcon = MinimizedIcon(Images.TinyIcon, 32, 32, AltHolicWindow:SetVisible(false));
MainTinyIcon24 = MinimizedIcon(Images.TinyIcon24, 24, 24, AltHolicWindow:SetVisible(false));
MainTinyIcon16 = MinimizedIcon(Images.TinyIcon16, 16, 16, AltHolicWindow:SetVisible(false));

MainMinimizedIcon:SetPosition(settings["IconPosition"]["xPosIcon"], settings["IconPosition"]["yPosIcon"]);
MainMinimizedIcon:SetZOrder(0);

MainTinyIcon:SetPosition(settings["IconPosition"]["xPosIcon"], settings["IconPosition"]["yPosIcon"]);
MainTinyIcon:SetZOrder(0);

MainTinyIcon24:SetPosition(settings["IconPosition"]["xPosIcon"], settings["IconPosition"]["yPosIcon"]);
MainTinyIcon24:SetZOrder(0);

MainTinyIcon16:SetPosition(settings["IconPosition"]["xPosIcon"], settings["IconPosition"]["yPosIcon"]);
MainTinyIcon16:SetZOrder(0);

MainMinimizedIcon.PositionChanged = function()
	settings["IconPosition"]["xPosIcon"] = MainMinimizedIcon:GetLeft();
	settings["IconPosition"]["yPosIcon"] = MainMinimizedIcon:GetTop();
end
    
UpdateMinimizedIcon();

------------------------------------------------------------------------------------------
-- create or load the settings for player professions
------------------------------------------------------------------------------------------
-- test for profession
local currentLevel = {};
local ProfessionName = {};
local currentLevelMastery = {};

function GetDataForProfessions()
    character = {};

    tier = {Strings.PluginProfTier1,
            Strings.PluginProfTier2,
            Strings.PluginProfTier3,
            Strings.PluginProfTier4,
            Strings.PluginProfTier5,
            Strings.PluginProfTier6,
            Strings.PluginProfTier7,
            Strings.PluginProfTier8,
            Strings.PluginProfTier9,
            Strings.PluginProfTier10,
            Strings.PluginProfTier11,
            Strings.PluginProfTier12,
            Strings.PluginProfTier13};

    if PlayerVoc then
	    character.professions = {};

        local profNbr = 1;

	    for k,v in pairs(Turbine.Gameplay.Profession) do
		    local professionInfo = PlayerAttr:GetProfessionInfo(v);

		    if professionInfo then
			    local professionData = {};
			
			    professionData.proficiencyLevel = professionInfo:GetProficiencyLevel();
			    professionData.masteryLevel = professionInfo:GetMasteryLevel();
			    professionData.proficiencyExp = professionInfo:GetProficiencyExperience();
			    professionData.proficiencyExpTarget = professionInfo:GetProficiencyExperienceTarget();
			    professionData.masteryExp = professionInfo:GetMasteryExperience();
			    professionData.masteryExpTarget = professionInfo:GetMasteryExperienceTarget();
                professionData.name = professionInfo:GetName();


                local valForNextLvlProficiency = Round((professionData.proficiencyExpTarget - professionData.proficiencyExp) / 8);
                local valForNextLvlMastery = Round((professionData.masteryExpTarget - professionData.masteryExp) / 8);


                -- debug
                --professionData.proficiencyLevel = 13;
                --professionData.masteryLevel = 13;
                -- end debug

                if(professionData.proficiencyLevel < 13)then
                    currentLevel[profNbr] = tostring("T" .. professionData.proficiencyLevel+1) .. " - " .. 
                    tostring(tier[professionData.proficiencyLevel+1]) .. " : " .. 
                    tostring(professionData.proficiencyExp) .. " / " .. tostring(professionData.proficiencyExpTarget .. "\n" .. "      ~ " .. valForNextLvlProficiency .. " " .. Strings.PluginProfTier20);
                else
                    currentLevel[profNbr] = tostring("T" .. professionData.proficiencyLevel) .. " - " .. 
                    tostring(tier[professionData.proficiencyLevel]) .. 
                    tostring("\n" .. "        " .. Strings.PluginProfTier21);
                end
                if(professionData.masteryLevel < 13)then
                    currentLevelMastery[profNbr] = tostring("T" .. professionData.masteryLevel+1) .. " - " .. 
                    tostring(tier[professionData.masteryLevel+1]) .. " : " .. 
                    tostring(professionData.masteryExp) .. " / " .. tostring(professionData.masteryExpTarget .. "\n" .. "      ~ " .. valForNextLvlMastery .. " " .. Strings.PluginProfTier20);
                else
                    currentLevelMastery[profNbr] = tostring("T" .. professionData.masteryLevel) .. " - " .. 
                    tostring(tier[professionData.masteryLevel]) .. 
                    tostring("\n" .. "        " .. Strings.PluginProfTier21);
                end
                
                ProfessionName[profNbr] = tostring(professionData.name);

                profNbr = profNbr + 1;
            end
        end
    end
end

GetDataForProfessions();

------------------------------------------------------------------------------------------
-- create or load the settings for player professions
------------------------------------------------------------------------------------------
function LoadPlayerProfessions()
    PlayerProfessions = PatchDataLoad(Turbine.DataScope.Account, "AltHolic_PlayerProfessions", PlayerProfessions);

    if (PlayerProfessions == nil)then 
        PlayerProfessions = {}; 
    end

    if (PlayerProfessions[PlayerName] == nil)then 
        PlayerProfessions[PlayerName] = {}; 
    end

    if (PlayerProfessions[PlayerName].name == nil)then 
        PlayerProfessions[PlayerName].name = {}; 
    end

    if (PlayerProfessions[PlayerName].CurrentLvl == nil)then 
        PlayerProfessions[PlayerName].CurrentLvl = {}; 
    end

    if (PlayerProfessions[PlayerName].currentMastery == nil)then 
        PlayerProfessions[PlayerName].currentMastery = {}; 
    end
end
------------------------------------------------------------------------------------------
-- create the save settings for player professions
------------------------------------------------------------------------------------------
function SavePlayerProfessions()
    if ( string.sub( PlayerName, 1, 1 ) == "~" )then return end; --Ignore session play

    PlayerProfessions[PlayerName] = {};
    PlayerProfessions[PlayerName].Name = {}; 
    PlayerProfessions[PlayerName].CurrentLvl = {}; 
    PlayerProfessions[PlayerName].currentMastery = {}; 

    PlayerProfessions[PlayerName].Name = ProfessionName;
    PlayerProfessions[PlayerName].CurrentLvl = currentLevel;
    PlayerProfessions[PlayerName].currentMastery = currentLevelMastery;

    PatchDataSave( Turbine.DataScope.Account, "AltHolic_PlayerProfessions", PlayerProfessions);
end

LoadPlayerProfessions();
SavePlayerProfessions();