------------------------------------------------------------------------------------------
-- OptionWindow file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- define size of the window
------------------------------------------------------------------------------------------
local windowWidth = 0;
local windowHeight = 0;

windowWidth = 400;
windowHeight = 830;
------------------------------------------------------------------------------------------
-- create the options window
------------------------------------------------------------------------------------------
function GenerateOptionsWindow()
		OptionsWindow=Turbine.UI.Lotro.GoldWindow(); 
		OptionsWindow:SetSize(windowWidth, windowHeight); 
		OptionsWindow:SetText(Strings.PluginOptionsText); 

		OptionsWindow.Message=Turbine.UI.Label(); 
		OptionsWindow.Message:SetParent(OptionsWindow); 
		OptionsWindow.Message:SetSize(150,10); 
		OptionsWindow.Message:SetPosition(windowWidth/2 - 75, windowHeight - 17 ); 
		OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		OptionsWindow.Message:SetText(Strings.PluginText); 

		OptionsWindow:SetZOrder(0);
		OptionsWindow:SetWantsKeyEvents(true);

		OptionsWindow:SetPosition((Turbine.UI.Display:GetWidth()-OptionsWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-OptionsWindow:GetHeight())/2);

		OptionsWindow:SetVisible(false);
		------------------------------------------------------------------------------------------
		-- option center panel --
		------------------------------------------------------------------------------------------
		posx = 50;
		posy = 60;

		colorUsedFortexte = Turbine.UI.Color.Lime;
		colorUsedForLines = Turbine.UI.Color.Blue;

		TitleDisplayer(OptionsWindow, posx, posy, Strings.PluginOption11, colorUsedFortexte, colorUsedForLines);

		posy = posy + 10;

		OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy ); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption1); 

			posy = posy + 25;

			checkBoxKeep = Turbine.UI.Lotro.CheckBox();
			checkBoxKeep:SetParent( OptionsWindow );
			checkBoxKeep:SetSize(250, 40); 
			checkBoxKeep:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxKeep:SetText(Strings.PluginOption2);
			checkBoxKeep:SetPosition(posx + 50, posy);
			checkBoxKeep:SetVisible(true);
			if(settings["verbose"]["value"] == true)then
				checkBoxKeep:SetChecked(true);
			else
				checkBoxKeep:SetChecked(false);
			end
			checkBoxKeep:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 50;
			------------------------------------------------------------------------------------------
			-- spentcash
			------------------------------------------------------------------------------------------
			TitleDisplayer(OptionsWindow, posx, posy, Strings.PluginOption16, colorUsedFortexte, colorUsedForLines);

			posy = posy + 10;

			OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy ); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption17); 

			posy = posy + 25;

			checkBoxNormalIcon = Turbine.UI.Lotro.CheckBox();
			checkBoxNormalIcon:SetParent( OptionsWindow );
			checkBoxNormalIcon:SetSize(250, 40); 
			checkBoxNormalIcon:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxNormalIcon:SetText(Strings.PluginOption21);
			checkBoxNormalIcon:SetPosition((OptionsWindow:GetWidth()/2)-75, posy);
			checkBoxNormalIcon:SetVisible(true);
			if(settings["isMinimizeEnabled"]["isMinimizeEnabled"] == false)then
				checkBoxNormalIcon:SetChecked(true);
			else
				checkBoxNormalIcon:SetChecked(false);
			end
			checkBoxNormalIcon:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 25;

			checkBoxTinyIcon = Turbine.UI.Lotro.CheckBox();
			checkBoxTinyIcon:SetParent( OptionsWindow );
			checkBoxTinyIcon:SetSize(250, 40); 
			checkBoxTinyIcon:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxTinyIcon:SetText(Strings.PluginOption18);
			checkBoxTinyIcon:SetPosition((OptionsWindow:GetWidth()/2)-75, posy);
			checkBoxTinyIcon:SetVisible(true);
			if(settings["iconSize"]["value"] == 32 and settings["isMinimizeEnabled"]["isMinimizeEnabled"] == true)then
				checkBoxTinyIcon:SetChecked(true);
			else
				checkBoxTinyIcon:SetChecked(false);
			end
			checkBoxTinyIcon:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 25;

			checkBoxTinyIcon24 = Turbine.UI.Lotro.CheckBox();
			checkBoxTinyIcon24:SetParent( OptionsWindow );
			checkBoxTinyIcon24:SetSize(250, 40); 
			checkBoxTinyIcon24:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxTinyIcon24:SetText(Strings.PluginOption19);
			checkBoxTinyIcon24:SetPosition((OptionsWindow:GetWidth()/2)-75, posy);
			checkBoxTinyIcon24:SetVisible(true);
			if(settings["iconSize"]["value"] == 24 and settings["isMinimizeEnabled"]["isMinimizeEnabled"] == true)then
				checkBoxTinyIcon24:SetChecked(true);
			else
				checkBoxTinyIcon24:SetChecked(false);
			end
			checkBoxTinyIcon24:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 25;

			checkBoxTinyIcon16 = Turbine.UI.Lotro.CheckBox();
			checkBoxTinyIcon16:SetParent( OptionsWindow );
			checkBoxTinyIcon16:SetSize(250, 40); 
			checkBoxTinyIcon16:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxTinyIcon16:SetText(Strings.PluginOption20);
			checkBoxTinyIcon16:SetPosition((OptionsWindow:GetWidth()/2)-75, posy);
			checkBoxTinyIcon16:SetVisible(true);
			if(settings["iconSize"]["value"] == 16 and settings["isMinimizeEnabled"]["isMinimizeEnabled"] == true)then
				checkBoxTinyIcon16:SetChecked(true);
			else
				checkBoxTinyIcon16:SetChecked(false);
			end
			checkBoxTinyIcon16:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 50;

			function checkBoxNormalIcon:CheckedChanged()
				if(checkBoxNormalIcon:IsChecked(true))then
					checkBoxTinyIcon24:SetChecked(false);
					checkBoxTinyIcon16:SetChecked(false);
					checkBoxTinyIcon:SetChecked(false);
				end
			end

			function checkBoxTinyIcon:CheckedChanged()
				if(checkBoxTinyIcon:IsChecked(true))then
					checkBoxTinyIcon24:SetChecked(false);
					checkBoxTinyIcon16:SetChecked(false);
					checkBoxNormalIcon:SetChecked(false);
				end
			end

			function checkBoxTinyIcon24:CheckedChanged()
				if(checkBoxTinyIcon24:IsChecked(true))then
					checkBoxTinyIcon:SetChecked(false);
					checkBoxTinyIcon16:SetChecked(false);
					checkBoxNormalIcon:SetChecked(false);
				end
			end

			function checkBoxTinyIcon16:CheckedChanged()
				if(checkBoxTinyIcon16:IsChecked(true))then
					checkBoxTinyIcon24:SetChecked(false);
					checkBoxTinyIcon:SetChecked(false);
					checkBoxNormalIcon:SetChecked(false);
				end
			end

			------------------------------------------------------------------------------------------
			-- spentcash
			------------------------------------------------------------------------------------------

		TitleDisplayer(OptionsWindow, posx, posy, Strings.PluginOption12, colorUsedFortexte, colorUsedForLines);

		posy = posy + 5;

			OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption3); 

			posy = posy + 25;

			checkBoxSpent = Turbine.UI.Lotro.CheckBox();
			checkBoxSpent:SetParent( OptionsWindow );
			checkBoxSpent:SetSize(250, 40); 
			checkBoxSpent:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxSpent:SetText(Strings.PluginOption4);
			checkBoxSpent:SetPosition(posx + 100, posy);
			checkBoxSpent:SetVisible(true);
			if(settings["displaySpentCash"]["value"] == true)then
				checkBoxSpent:SetChecked(true);
			else
				checkBoxSpent:SetChecked(false);
			end
			checkBoxSpent:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 30;
			------------------------------------------------------------------------------------------
			-- total cash
			------------------------------------------------------------------------------------------
			OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption8); 

			posy = posy + 25;

			checkBoxCashTotal = Turbine.UI.Lotro.CheckBox();
			checkBoxCashTotal:SetParent( OptionsWindow );
			checkBoxCashTotal:SetSize(250, 40); 
			checkBoxCashTotal:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxCashTotal:SetText(Strings.PluginOption4);
			checkBoxCashTotal:SetPosition(posx + 100, posy);
			checkBoxCashTotal:SetVisible(true);
			if(settings["displayTotalCash"]["value"] == true)then
				checkBoxCashTotal:SetChecked(true);
			else
				checkBoxCashTotal:SetChecked(false);
			end
			checkBoxCashTotal:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 50;
			------------------------------------------------------------------------------------------
			-- class bags
			------------------------------------------------------------------------------------------
			TitleDisplayer(OptionsWindow, posx, posy, Strings.PluginOption13, colorUsedFortexte, colorUsedForLines);

		posy = posy + 5;

			OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption5); 

			posy = posy + 25;

			checkBoxClassBag = Turbine.UI.Lotro.CheckBox();
			checkBoxClassBag:SetParent( OptionsWindow );
			checkBoxClassBag:SetSize(250, 40); 
			checkBoxClassBag:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxClassBag:SetText(Strings.PluginOption4);
			checkBoxClassBag:SetPosition(posx + 100, posy );
			checkBoxClassBag:SetVisible(true);
			if(settings["displayClassBags"]["value"] == true)then
				checkBoxClassBag:SetChecked(true);
			else
				checkBoxClassBag:SetChecked(false);
			end
			checkBoxClassBag:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 50;
			------------------------------------------------------------------------------------------
			-- durability color
			------------------------------------------------------------------------------------------
			TitleDisplayer(OptionsWindow, posx, posy, Strings.PluginOption14, colorUsedFortexte, colorUsedForLines);

		posy = posy + 10;

			OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption7); 

			posy = posy + 25;

			checkBoxClassDUColor = Turbine.UI.Lotro.CheckBox();
			checkBoxClassDUColor:SetParent( OptionsWindow );
			checkBoxClassDUColor:SetSize(250, 40); 
			checkBoxClassDUColor:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxClassDUColor:SetText(Strings.PluginOption4);
			checkBoxClassDUColor:SetPosition(posx + 100, posy + 10);
			checkBoxClassDUColor:SetVisible(true);
			if(settings["displayDurabilityColor"]["value"] == true)then
				checkBoxClassDUColor:SetChecked(true);
			else
				checkBoxClassDUColor:SetChecked(false);
			end
			checkBoxClassDUColor:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 60;
			------------------------------------------------------------------------------------------
			-- display reput points
			------------------------------------------------------------------------------------------
			TitleDisplayer(OptionsWindow, posx, posy, Strings.PluginOption15, colorUsedFortexte, colorUsedForLines);

		posy = posy + 5;

			OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption9); 

			posy = posy + 25;

			checkBoxDisplayReput = Turbine.UI.Lotro.CheckBox();
			checkBoxDisplayReput:SetParent( OptionsWindow );
			checkBoxDisplayReput:SetSize(250, 40); 
			checkBoxDisplayReput:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxDisplayReput:SetText(Strings.PluginOption4);
			checkBoxDisplayReput:SetPosition(posx + 100, posy );
			checkBoxDisplayReput:SetVisible(true);
			if(settings["showProgressReput"]["value"] == true)then
				checkBoxDisplayReput:SetChecked(true);
			else
				checkBoxDisplayReput:SetChecked(false);
			end
			checkBoxDisplayReput:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));

			posy = posy + 30;

			------------------------------------------------------------------------------------------
			-- display lotro points
			------------------------------------------------------------------------------------------
			OptionsWindow.Message=Turbine.UI.Label(); 
			OptionsWindow.Message:SetParent(OptionsWindow); 
			OptionsWindow.Message:SetSize(300, 40); 
			OptionsWindow.Message:SetPosition(posx, posy); 
			OptionsWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			OptionsWindow.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			OptionsWindow.Message:SetText(Strings.PluginOption10); 

			posy = posy + 25;

			checkBoxDisplayLotro = Turbine.UI.Lotro.CheckBox();
			checkBoxDisplayLotro:SetParent( OptionsWindow );
			checkBoxDisplayLotro:SetSize(250, 40); 
			checkBoxDisplayLotro:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			checkBoxDisplayLotro:SetText(Strings.PluginOption4);
			checkBoxDisplayLotro:SetPosition(posx + 100, posy );
			checkBoxDisplayLotro:SetVisible(true);
			if(settings["showProgressLotro"]["value"] == true)then
				checkBoxDisplayLotro:SetChecked(true);
			else
				checkBoxDisplayLotro:SetChecked(false);
			end
			checkBoxDisplayLotro:SetForeColor( Turbine.UI.Color( 0.7, 0.6, 0.2 ));




			if(settings["nameAccount"]["account1"]["nbrAlt"] >= 1)then
				buttonDefineGendre = Turbine.UI.Lotro.GoldButton();
				buttonDefineGendre:SetParent( OptionsWindow );
				buttonDefineGendre:SetPosition(windowWidth/2 - 125,  windowHeight - 80);
				buttonDefineGendre:SetSize( 300, 20 );
				buttonDefineGendre:SetFont(Turbine.UI.Lotro.Font.Verdana16);
				buttonDefineGendre:SetText( Strings.PluginOption6 );
				buttonDefineGendre:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
				buttonDefineGendre:SetVisible(true);
				buttonDefineGendre:SetMouseVisible(true);
			end




			buttonValider = Turbine.UI.Lotro.GoldButton();
			buttonValider:SetParent( OptionsWindow );
			buttonValider:SetPosition(windowWidth/2 - 125,  windowHeight - 50);
			buttonValider:SetSize( 300, 20 );
			buttonValider:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			buttonValider:SetText( Strings.PluginOptionValidate );
			buttonValider:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
			buttonValider:SetVisible(true);
			buttonValider:SetMouseVisible(true);


		ValidateChangesOptions();
		if(settings["nameAccount"]["account1"]["nbrAlt"] >= 1)then
			OpenChangesGendre();
		end
		ClosingTheWindowOptions();

		OptionsWindow.KeyDown=function(sender, args)
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			OptionsWindow:SetVisible(false);
			settings["isOptionsWindowVisible"]["isOptionsWindowVisible"] = false;
		end
	
		-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
		if ( args.Action == 268435635 ) then
			hudVisible=not hudVisible;
			if hudVisible then
				OptionsWindow:SetVisible(false);
				MainMinimizedIcon:SetVisible(false);
				MainTinyIcon:SetVisible(false);
			else
				OptionsWindow:SetVisible(settings.isOptionsWindowVisible);
				UpdateMinimizedIcon();
			end
		end
	end
end
------------------------------------------------------------------------------------------
-- boutton valider
------------------------------------------------------------------------------------------
function ValidateChangesOptions()
	buttonValider.MouseClick = function(sender, args)
			if (checkBoxKeep:IsChecked()) then
				settings["verbose"]["value"] = true;
			else
				settings["verbose"]["value"] = false;
			end

			if (checkBoxNormalIcon:IsChecked()) then
				settings["isMinimizeEnabled"]["isMinimizeEnabled"] = false;
			else
				settings["isMinimizeEnabled"]["isMinimizeEnabled"] = true;
			end

			if (checkBoxTinyIcon:IsChecked()) then
				settings["iconSize"]["value"] = 32;
			end
			
			if (checkBoxTinyIcon24:IsChecked()) then
				settings["iconSize"]["value"] = 24;
			end

			if (checkBoxTinyIcon16:IsChecked()) then
				settings["iconSize"]["value"] = 16;
			end

			if (checkBoxSpent:IsChecked()) then
				settings["displaySpentCash"]["value"] = true;
			else
				settings["displaySpentCash"]["value"] = false;
			end

			if (checkBoxClassBag:IsChecked()) then
				settings["displayClassBags"]["value"] = true;
			else
				settings["displayClassBags"]["value"] = false;
			end

			if (checkBoxClassDUColor:IsChecked()) then
				settings["displayDurabilityColor"]["value"] = true;
			else
				settings["displayDurabilityColor"]["value"] = false;
			end

			if (checkBoxDisplayReput:IsChecked()) then
				settings["showProgressReput"]["value"] = true;
			else
				settings["showProgressReput"]["value"] = false;
			end

			if (checkBoxDisplayLotro:IsChecked()) then
				settings["showProgressLotro"]["value"] = true;
			else
				settings["showProgressLotro"]["value"] = false;
			end

			if (checkBoxCashTotal:IsChecked()) then
				settings["displayTotalCash"]["value"] = true;
			else
				settings["displayTotalCash"]["value"] = false;
			end


			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginOptionNotificationsActivated);
				if(settings["displaySpentCash"]["value"] == true)then
					Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginOptionSpentCashActivated);
				else
					Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginOptionSpentCashDeactivated);
				end
			else
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginOptionNotificationsDeactivated);
			end

			OptionsWindow:SetVisible(false);
			settings["isOptionsWindowVisible"]["isOptionsWindowVisible"] = false;
			SavePlayerDatas();
			UpdateMainWindow();
			UpdateMinimizedIcon();
			settings["isWindowVisible"]["isWindowVisible"] = true;
			AltHolicWindow:SetVisible(true);
		end
end

function OpenChangesGendre()
	buttonDefineGendre.MouseClick = function(sender, args)
		GenerateGendreWindow();
		GendreWindow:SetVisible(true);
	end
end