------------------------------------------------------------------------------------------
-- PlayerStats file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
-- define player stats
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Define vars --
------------------------------------------------------------------------------------------
    Player = Turbine.Gameplay.LocalPlayer.GetInstance();
    vaultpack = Player:GetVault();
    sspack = Player:GetSharedStorage();
    walletpack = Player:GetWallet();
    backpack = Player:GetBackpack();
    PlayerName = Player:GetName();
    PlayerAlign = Player:GetAlignment(); --1: Free People / 2: Monster Play
    PlayerLvl = Player:GetLevel();
    PlayerAttr = Player:GetAttributes();
    PlayerAlignement = Player:GetAlignment();
    PlayerEquip = Player:GetEquipment();
    PlayerDestinyP = PlayerAttr:GetDestinyPoints();
    PlayerSexe = {};
    EpiqueVolume = {};
    EpiqueLivre = {};
    EpiqueChapitre = {};
    Reputations = {};
    RepuPosition = {};
    RepuName = {};

    valCheck = 200;

    nbrFactions = 89;
    ------------------------------------------------------------------------------------------
    -- define player dats for stats
    ------------------------------------------------------------------------------------------
    if(PlayerAlignement == 1)then
        PlayerAgility = tonumber(PlayerAttr:GetAgility());
        PlayerFate = tonumber(PlayerAttr:GetFate());
        PlayerMight = tonumber(PlayerAttr:GetMight());
        PlayerVitality = tonumber(PlayerAttr:GetVitality());
        PlayerWill = tonumber(PlayerAttr:GetWill());
        PlayerArmure = tonumber(PlayerAttr:GetArmor());
        PlayerMoral = tonumber(Player:GetMorale());
        PlayerMaxMoral = tonumber(Player:GetMaxMorale());
        PlayerPower = tonumber(Player:GetPower());
        PlayerMaxPower = tonumber(Player:GetMaxPower());
	    PlayerVoc = PlayerAttr:GetVocation();
        -- new large stats
        PlayerCritAttack = tonumber(PlayerAttr:GetBaseCriticalHitChance());
        PlayerFinesse = tonumber(PlayerAttr:GetFinesse());
        PlayerMeleeDamage = tonumber(PlayerAttr:GetMeleeDamage());
        PlayerTacticalDamage = tonumber(PlayerAttr:GetTacticalDamage());
        PlayerDegatPhysique = tonumber(PlayerAttr:GetCommonMitigation());
        PlayerDegatTactique = tonumber(PlayerAttr:GetTacticalMitigation());
        PlayerDefenseCritique = tonumber(PlayerAttr:GetBaseCriticalHitAvoidance());
        PlayerResistance = tonumber(PlayerAttr:GetBaseResistance());
        PlayerBloquage = tonumber(PlayerAttr:GetBlock());
        PlayerParade = tonumber(PlayerAttr:GetParry());
        PlayerEsquive = tonumber(PlayerAttr:GetEvade());
        PlayerHealDone = tonumber(PlayerAttr:GetOutgoingHealing());
        PlayerHealRecieved = tonumber(PlayerAttr:GetIncomingHealing());
        PlayerOrc = tonumber(PlayerAttr:GetPhysicalMitigation());
        PlayerRange = tonumber(PlayerAttr:GetRangeDamage());
    else
        PlayerMoral = tonumber(Player:GetMorale());
        PlayerMaxMoral = tonumber(Player:GetMaxMorale());
        PlayerPower = tonumber(Player:GetPower());
        PlayerMaxPower = tonumber(Player:GetMaxPower());
    end

    PlayerClass = Player:GetClass();
    PlayerRace = Player:GetRace();
    PlayerCash = PlayerAttr:GetMoney();


vaultHasBeenUpdated = false;
sharedStorageHasBeenUpdated = false;
------------------------------------------------------------------------------------------
-- load all the dats needed
------------------------------------------------------------------------------------------
LoadSettings();
LoadPlayerDatas();
LoadPlayerEquipment();
LoadPlayerVault();
LoadPlayerBags();
LoadSharedStorage();
LoadPlayerWallet();
LoadPlayerEpique();
LoadPlayerReputations();
LoadPlayerInfos();

PlayerSexe[PlayerName] = PlayerDatas[PlayerName].sexe;

SavePlayerBags();
SavePlayerDatas();
SavePlayerWallet();

local Today = Turbine.Engine.GetDate();
local TodayDay = Today.Day;
local TodayMonth = Today.Month;
local TodayYear = Today.Year;
------------------------------------------------------------------------------------------
-- define daily cash value
------------------------------------------------------------------------------------------
if(settings["dailyCash"]["jour"] ~= TodayDay or settings["dailyCash"]["mois"] ~= TodayMonth or settings["dailyCash"]["annee"] ~= TodayYear)then
    settings["dailyCash"]["cashDaily"] = 0;
    settings["dailyCash"]["cashSpent"] = 0;
    settings["dailyCash"]["jour"] = TodayDay;
    settings["dailyCash"]["mois"] = TodayMonth;
    settings["dailyCash"]["annee"] = TodayYear;
end
------------------------------------------------------------------------------------------
-- define level equipment
------------------------------------------------------------------------------------------
    PlayerEquipItems = {};
    PlayerEquipItems[PlayerName] = {};
    if(PlayerEquipement[PlayerName].Back.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Back = PlayerEquipement[PlayerName].Back.lvl;
        PlayerEquipItems[PlayerName].BackN = PlayerEquipement[PlayerName].Back.N;
    else
        PlayerEquipItems[PlayerName].Back = 0;
    end
    if(PlayerEquipement[PlayerName].Boots.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Boots = PlayerEquipement[PlayerName].Boots.lvl;
        PlayerEquipItems[PlayerName].BootsN = PlayerEquipement[PlayerName].Boots.N;
    else
        PlayerEquipItems[PlayerName].Boots = 0;
    end
    if(PlayerEquipement[PlayerName].Bracelet1.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Bracelet1 = PlayerEquipement[PlayerName].Bracelet1.lvl;
        PlayerEquipItems[PlayerName].Bracelet1N = PlayerEquipement[PlayerName].Bracelet1.N;
    else
        PlayerEquipItems[PlayerName].Bracelet1 = 0;
    end
    if(PlayerEquipement[PlayerName].Bracelet2.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Bracelet2 = PlayerEquipement[PlayerName].Bracelet2.lvl;
        PlayerEquipItems[PlayerName].Bracelet2N = PlayerEquipement[PlayerName].Bracelet2.N;
    else
        PlayerEquipItems[PlayerName].Bracelet2 = 0;
    end
    if(PlayerEquipement[PlayerName].ClassE.lvl ~= 0)then
        PlayerEquipItems[PlayerName].ClassE = PlayerEquipement[PlayerName].ClassE.lvl;
        PlayerEquipItems[PlayerName].ClassEN = PlayerEquipement[PlayerName].ClassE.N;
    else
        PlayerEquipItems[PlayerName].ClassE = 0;
    end
    if(PlayerEquipement[PlayerName].CraftTool.lvl ~= 0)then
        PlayerEquipItems[PlayerName].CraftTool = PlayerEquipement[PlayerName].CraftTool.lvl;
        PlayerEquipItems[PlayerName].CraftToolN = PlayerEquipement[PlayerName].CraftTool.N;
    else
        PlayerEquipItems[PlayerName].CraftTool = 0;
    end
    if(PlayerEquipement[PlayerName].Earring1.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Earring1 = PlayerEquipement[PlayerName].Earring1.lvl;
        PlayerEquipItems[PlayerName].Earring1N = PlayerEquipement[PlayerName].Earring1.N;
    else
        PlayerEquipItems[PlayerName].Earring1 = 0;
    end
    if(PlayerEquipement[PlayerName].Earring2.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Earring2 = PlayerEquipement[PlayerName].Earring2.lvl;
        PlayerEquipItems[PlayerName].Earring2N = PlayerEquipement[PlayerName].Earring2.N;
    else
        PlayerEquipItems[PlayerName].Earring2 = 0;
    end
    if(PlayerEquipement[PlayerName].Gloves.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Gloves = PlayerEquipement[PlayerName].Gloves.lvl;
        PlayerEquipItems[PlayerName].GlovesN = PlayerEquipement[PlayerName].Gloves.N;
    else
        PlayerEquipItems[PlayerName].Gloves = 0;
    end
    if(PlayerEquipement[PlayerName].Head.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Head = PlayerEquipement[PlayerName].Head.lvl;
        PlayerEquipItems[PlayerName].HeadN = PlayerEquipement[PlayerName].Head.N;
    else
        PlayerEquipItems[PlayerName].Head = 0;
    end
    if(PlayerEquipement[PlayerName].Legs.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Legs = PlayerEquipement[PlayerName].Legs.lvl;
        PlayerEquipItems[PlayerName].LegsN = PlayerEquipement[PlayerName].Legs.N;
    else
        PlayerEquipItems[PlayerName].Legs = 0;
    end
    if(PlayerEquipement[PlayerName].Chest.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Chest = PlayerEquipement[PlayerName].Chest.lvl;
        PlayerEquipItems[PlayerName].ChestN = PlayerEquipement[PlayerName].Chest.N;
    else
        PlayerEquipItems[PlayerName].Chest = 0;
    end
    if(PlayerEquipement[PlayerName].Necklace.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Necklace = PlayerEquipement[PlayerName].Necklace.lvl;
        PlayerEquipItems[PlayerName].NecklaceN = PlayerEquipement[PlayerName].Necklace.N;
    else
        PlayerEquipItems[PlayerName].Necklace = 0;
    end
    if(PlayerEquipement[PlayerName].Pocket.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Pocket = PlayerEquipement[PlayerName].Pocket.lvl;
        PlayerEquipItems[PlayerName].PocketN = PlayerEquipement[PlayerName].Pocket.N;
    else
        PlayerEquipItems[PlayerName].Pocket = 0;
    end
    if(PlayerEquipement[PlayerName].PrimaryWeapon.lvl ~= 0)then
        PlayerEquipItems[PlayerName].PrimaryWeapon = PlayerEquipement[PlayerName].PrimaryWeapon.lvl;
        PlayerEquipItems[PlayerName].PrimaryWeaponN = PlayerEquipement[PlayerName].PrimaryWeapon.N;
    else
        PlayerEquipItems[PlayerName].PrimaryWeapon = 0;
    end
    if(PlayerEquipement[PlayerName].RangedWeapon.lvl ~= 0)then
        PlayerEquipItems[PlayerName].RangedWeapon = PlayerEquipement[PlayerName].RangedWeapon.lvl;
        PlayerEquipItems[PlayerName].RangedWeaponN = PlayerEquipement[PlayerName].RangedWeapon.N;
    else
        PlayerEquipItems[PlayerName].RangedWeapon = 0;
    end
    if(PlayerEquipement[PlayerName].Ring1.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Ring1 = PlayerEquipement[PlayerName].Ring1.lvl;
        PlayerEquipItems[PlayerName].Ring1N = PlayerEquipement[PlayerName].Ring1.N;
    else
        PlayerEquipItems[PlayerName].Ring1 = 0;
    end
    if(PlayerEquipement[PlayerName].Ring2.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Ring2 = PlayerEquipement[PlayerName].Ring2.lvl;
        PlayerEquipItems[PlayerName].Ring2N = PlayerEquipement[PlayerName].Ring2.N;
    else
        PlayerEquipItems[PlayerName].Ring2 = 0;
    end
    if(PlayerEquipement[PlayerName].Shield.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Shield = PlayerEquipement[PlayerName].Shield.lvl;
        PlayerEquipItems[PlayerName].ShieldN = PlayerEquipement[PlayerName].Shield.N;
    else
        PlayerEquipItems[PlayerName].Shield = 0;
    end
    if(PlayerEquipement[PlayerName].Shoulder.lvl ~= 0)then
        PlayerEquipItems[PlayerName].Shoulder = PlayerEquipement[PlayerName].Shoulder.lvl;
        PlayerEquipItems[PlayerName].ShoulderN = PlayerEquipement[PlayerName].Shoulder.N;
    else
        PlayerEquipItems[PlayerName].Shoulder = 0;
    end
------------------------------------------------------------------------------------------ 
-- define armor equipment
------------------------------------------------------------------------------------------
    PlayerEquipArmor = {};
    PlayerEquipArmor[PlayerName] = {};
    if(PlayerEquipement[PlayerName].Back.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Back = PlayerEquipement[PlayerName].Back.armor;
    else
        PlayerEquipArmor[PlayerName].Back = 0;
    end
    if(PlayerEquipement[PlayerName].Boots.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Boots = PlayerEquipement[PlayerName].Boots.armor;
    else
        PlayerEquipArmor[PlayerName].Boots = 0;
    end
    if(PlayerEquipement[PlayerName].Bracelet1.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Bracelet1 = PlayerEquipement[PlayerName].Bracelet1.armor;
    else
        PlayerEquipArmor[PlayerName].Bracelet1 = 0;
    end
    if(PlayerEquipement[PlayerName].Bracelet2.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Bracelet2 = PlayerEquipement[PlayerName].Bracelet2.armor;
    else
        PlayerEquipArmor[PlayerName].Bracelet2 = 0;
    end
    if(PlayerEquipement[PlayerName].ClassE.armor ~= 0)then
        PlayerEquipArmor[PlayerName].ClassE = PlayerEquipement[PlayerName].ClassE.armor;
    else
        PlayerEquipArmor[PlayerName].ClassE = 0;
    end
    if(PlayerEquipement[PlayerName].CraftTool.armor ~= 0)then
        PlayerEquipArmor[PlayerName].CraftTool = PlayerEquipement[PlayerName].CraftTool.armor;
    else
        PlayerEquipArmor[PlayerName].CraftTool = 0;
    end
    if(PlayerEquipement[PlayerName].Earring1.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Earring1 = PlayerEquipement[PlayerName].Earring1.armor;
    else
        PlayerEquipArmor[PlayerName].Earring1 = 0;
    end
    if(PlayerEquipement[PlayerName].Earring2.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Earring2 = PlayerEquipement[PlayerName].Earring2.armor;
    else
        PlayerEquipArmor[PlayerName].Earring2 = 0;
    end
    if(PlayerEquipement[PlayerName].Gloves.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Gloves = PlayerEquipement[PlayerName].Gloves.armor;
    else
        PlayerEquipArmor[PlayerName].Gloves = 0;
    end
    if(PlayerEquipement[PlayerName].Head.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Head = PlayerEquipement[PlayerName].Head.armor;
    else
        PlayerEquipArmor[PlayerName].Head = 0;
    end
    if(PlayerEquipement[PlayerName].Legs.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Legs = PlayerEquipement[PlayerName].Legs.armor;
    else
        PlayerEquipArmor[PlayerName].Legs = 0;
    end
    if(PlayerEquipement[PlayerName].Chest.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Chest = PlayerEquipement[PlayerName].Chest.armor;
    else
        PlayerEquipArmor[PlayerName].Chest = 0;
    end
    if(PlayerEquipement[PlayerName].Necklace.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Necklace = PlayerEquipement[PlayerName].Necklace.armor;
    else
        PlayerEquipArmor[PlayerName].Necklace = 0;
    end
    if(PlayerEquipement[PlayerName].Pocket.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Pocket = PlayerEquipement[PlayerName].Pocket.armor;
    else
        PlayerEquipArmor[PlayerName].Pocket = 0;
    end
    if(PlayerEquipement[PlayerName].PrimaryWeapon.armor ~= 0)then
        PlayerEquipArmor[PlayerName].PrimaryWeapon = PlayerEquipement[PlayerName].PrimaryWeapon.armor;
    else
        PlayerEquipArmor[PlayerName].PrimaryWeapon = 0;
    end
    if(PlayerEquipement[PlayerName].RangedWeapon.armor ~= 0)then
        PlayerEquipArmor[PlayerName].RangedWeapon = PlayerEquipement[PlayerName].RangedWeapon.armor;
    else
        PlayerEquipArmor[PlayerName].RangedWeapon = 0;
    end
    if(PlayerEquipement[PlayerName].Ring1.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Ring1 = PlayerEquipement[PlayerName].Ring1.armor;
    else
        PlayerEquipArmor[PlayerName].Ring1 = 0;
    end
    if(PlayerEquipement[PlayerName].Ring2.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Ring2 = PlayerEquipement[PlayerName].Ring2.armor;
    else
        PlayerEquipArmor[PlayerName].Ring2 = 0;
    end
    if(PlayerEquipement[PlayerName].Shield.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Shield = PlayerEquipement[PlayerName].Shield.armor;
    else
        PlayerEquipArmor[PlayerName].Shield = 0;
    end
    if(PlayerEquipement[PlayerName].Shoulder.armor ~= 0)then
        PlayerEquipArmor[PlayerName].Shoulder = PlayerEquipement[PlayerName].Shoulder.armor;
    else
        PlayerEquipArmor[PlayerName].Shoulder = 0;
    end
------------------------------------------------------------------------------------------
-- save equipment only for free people
------------------------------------------------------------------------------------------
if(Player:GetAlignment() == 1)then
	SavePlayerEquipment();
end